"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _path2 = _interopRequireDefault(require("path"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _default() {
  var lastOpts;
  var lastCwd;
  var lastPatterns;

  function selectPatterns(state) {
    var opts = state.opts;
    var cwd = state.cwd || process.cwd();
    if (opts === lastOpts && cwd === lastCwd) return lastPatterns;
    lastCwd = cwd;
    lastOpts = opts;
    var _opts$packages = opts.packages,
        packages = _opts$packages === void 0 ? [] : _opts$packages,
        _opts$patterns = opts.patterns,
        patterns = _opts$patterns === void 0 ? [] : _opts$patterns,
        _opts$paths = opts.paths,
        paths = _opts$paths === void 0 ? [] : _opts$paths;
    return lastPatterns = _toConsumableArray(packages.map(function (pkg) {
      return {
        pattern: new RegExp("^".concat(pkg, "(/|$)")),
        type: 'package',
        what: pkg
      };
    })).concat(_toConsumableArray(patterns.map(function (_pattern) {
      var pattern = Array.isArray(_pattern) ? new RegExp(_pattern[0], _pattern[1] || '') : new RegExp(_pattern, '');
      return {
        pattern: pattern,
        type: 'pattern',
        what: pattern
      };
    })), _toConsumableArray(paths.map(function (_path) {
      return {
        pattern: new RegExp("^".concat(_path2.default.resolve(cwd, _path), "(/|$)")),
        type: 'path',
        what: _path
      };
    })));
  }

  return {
    visitor: {
      ImportDeclaration: function ImportDeclaration(_path, state) {
        var filename = state.file && state.file.opts && state.file.opts.filename || state.filename;
        var cwd = state.cwd || process.cwd();
        var rawSource = _path.node.source.value;
        var source = /^[./]/.test(rawSource) ? _path2.default.resolve(_path2.default.dirname(filename), rawSource) : rawSource;
        var patterns = selectPatterns(state);
        patterns.forEach(function (_ref) {
          var pattern = _ref.pattern,
              type = _ref.type,
              what = _ref.what;

          if (pattern.test(source)) {
            var rule;

            switch (type) {
              case 'package':
                rule = "'".concat(what, "'");
                break;

              case 'pattern':
                rule = String(what);
                break;

              case 'path':
                rule = _path2.default.relative(_path2.default.dirname(filename), _path2.default.resolve(cwd, what));
                if (!/^\./.test(rule)) rule = "./".concat(rule);
                rule = "'".concat(rule, "'");
                break;
            }

            throw new Error("importing from ".concat(rule, " is forbidden (imported: '").concat(rawSource, "')"));
          }
        });
      }
    }
  };
}